Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4108)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4109)
@@ -20,5 +20,21 @@
 ! Current revisions:
 ! ------------------
-! 
+! - Separate initialization of advection flags for momentum and scalars. In this
+!   context, resort the bits and do some minor formatting. 
+! - Make flag initialization for scalars more flexible, introduce an 
+!   arguemnt list to indicate non-cyclic boundaries (required for decycled 
+!   scalars such as chemical species or aerosols)
+! - Introduce extended 'degradation zones', where horizontal advection of 
+!   passive scalars is discretized by first-order scheme at all grid points 
+!   that in the vicinity of buildings (<= 3 grid points). Even though no 
+!   building is within the numerical stencil, first-order scheme is used. 
+!   At fourth and fifth grid point the order of the horizontal advection scheme
+!   is successively upgraded.
+!   These extended degradation zones are used to avoid stationary numerical 
+!   oscillations, which are responsible for high concentration maxima that may
+!   appear under shear-free stable conditions. 
+! - Change interface for scalar advection routine. 
+! - Bugfix, avoid uninitialized value sk_num in vector version of scalar
+!   advection
 ! 
 ! Former revisions:
@@ -106,5 +122,5 @@
 ! Change in file header (GPL part)
 ! Implement advection for TKE-dissipation in case of RANS-TKE-e closure (TG)
-! Allocate advc_flags_1/2 within ws_init_flags instead of init_grid
+! Allocate advc_flags_m/2 within ws_init_flags instead of init_grid
 ! Change argument list for exchange_horiz_2d_int (MS)
 ! 
@@ -120,8 +136,8 @@
 ! 
 ! 2232 2017-05-30 17:47:52Z suehring
-! Rename wall_flags_0 and wall_flags_00 into advc_flags_1 and advc_flags_2, 
+! Rename wall_flags_0 and wall_flags_00 into advc_flags_m and advc_flags_m, 
 ! respectively.
-! Set advc_flags_1/2 on basis of wall_flags_0/00 instead of nzb_s/u/v/w_inner.
-! Setting advc_flags_1/2 also for downward-facing walls
+! Set advc_flags_m/2 on basis of wall_flags_0/00 instead of nzb_s/u/v/w_inner.
+! Setting advc_flags_m/2 also for downward-facing walls
 ! 
 ! 2200 2017-04-11 11:37:51Z suehring
@@ -246,5 +262,5 @@
 ! vector version.
 ! Degradation of the applied order of scheme is now steered by multiplying with
-! Integer advc_flags_1. 2nd order scheme, WS3 and WS5 are calculated on each
+! Integer advc_flags_m. 2nd order scheme, WS3 and WS5 are calculated on each
 ! grid point and mulitplied with the appropriate flag.
 ! 2nd order numerical dissipation term changed. Now the appropriate 2nd order
@@ -267,4 +283,9 @@
 !
 ! 411 2009-12-11 12:31:43 Z suehring
+!
+!
+!
+! @author Matthias Suehring
+!
 !
 ! Description:
@@ -282,4 +303,6 @@
 !>
 !> @todo Implement monotonic flux limiter also for vector version.
+!> @todo Move 3d arrays advc_flag, advc_flags_m from modules to advec_ws
+!> @todo Move arrays flux_l_x from modules to advec_ws
 !------------------------------------------------------------------------------!
  MODULE advec_ws
@@ -299,15 +322,47 @@
 
     USE control_parameters,                                                    &
-        ONLY:  humidity, loop_optimization, passive_scalar,                    &
-               rans_tke_e, ws_scheme_mom, ws_scheme_sca,                       &
-               momentum_advec, scalar_advec,                                   &
-               bc_dirichlet_l, bc_dirichlet_n, bc_dirichlet_r,                 &
-               bc_dirichlet_s, bc_radiation_l, bc_radiation_n,                 &
-               bc_radiation_r, bc_radiation_s, intermediate_timestep_count,    &
-               u_gtrans, v_gtrans, dt_3d
+        ONLY:  air_chemistry,                                                  &
+               bc_dirichlet_l,                                                 &
+               bc_dirichlet_n,                                                 &
+               bc_dirichlet_r,                                                 &
+               bc_dirichlet_s,                                                 &
+               bc_radiation_l,                                                 &
+               bc_radiation_n,                                                 &
+               bc_radiation_r,                                                 &
+               bc_radiation_s,                                                 &
+               humidity,                                                       &
+               loop_optimization,                                              &
+               passive_scalar,                                                 &
+               rans_tke_e,                                                     &
+               momentum_advec,                                                 &
+               salsa,                                                          &
+               scalar_advec,                                                   &
+               intermediate_timestep_count,                                    &
+               u_gtrans,                                                       &
+               v_gtrans,                                                       &
+               ws_scheme_mom,                                                  &
+               ws_scheme_sca,                                                  &
+               dt_3d
 
     USE indices,                                                               &
-        ONLY:  nbgp, nxl, nxlg, nxlu, nxr, nxrg, nyn, nyng, nys, nysg, nysv,   &
-               nzb, nzb_max, nzt, advc_flags_1, advc_flags_2, wall_flags_0
+        ONLY:  advc_flags_m,                                                   &
+               advc_flags_s,                                                   &
+               nbgp,                                                           &
+               nx,                                                             &
+               nxl,                                                            &
+               nxlg,                                                           &
+               nxlu,                                                           &
+               nxr,                                                            & 
+               nxrg,                                                           & 
+               ny,                                                             &
+               nyn,                                                            & 
+               nyng,                                                           & 
+               nys,                                                            &
+               nysg,                                                           &
+               nysv,                                                           &
+               nzb,                                                            &
+               nzb_max,                                                        &
+               nzt,                                                            &
+               wall_flags_0
 
     USE grid_variables,                                                        &
@@ -338,13 +393,17 @@
     PRIVATE
     PUBLIC   advec_s_ws, advec_u_ws, advec_v_ws, advec_w_ws, ws_init,          &
-             ws_init_flags, ws_statistics
+             ws_init_flags_momentum, ws_init_flags_scalar, ws_statistics
 
     INTERFACE ws_init
        MODULE PROCEDURE ws_init
-    END INTERFACE ws_init
-
-    INTERFACE ws_init_flags
-       MODULE PROCEDURE ws_init_flags
-    END INTERFACE ws_init_flags
+    END INTERFACE ws_init         
+             
+    INTERFACE ws_init_flags_momentum
+       MODULE PROCEDURE ws_init_flags_momentum
+    END INTERFACE ws_init_flags_momentum
+    
+    INTERFACE ws_init_flags_scalar
+       MODULE PROCEDURE ws_init_flags_scalar
+    END INTERFACE ws_init_flags_scalar
 
     INTERFACE ws_statistics
@@ -490,8 +549,9 @@
 ! Description:
 ! ------------
-!> Initialization of flags for WS-scheme used to degrade the order of the scheme
-!> near walls.
+!> Initialization of flags to control the order of the advection scheme near
+!> solid walls and non-cyclic inflow boundaries, where the order is sucessively
+!> degraded. 
 !------------------------------------------------------------------------------!
-    SUBROUTINE ws_init_flags
+    SUBROUTINE ws_init_flags_momentum
 
 
